/**
 * @mainpage libopencm3 Developer Documentation
 *
 * The libopencm3 project (previously known as libopenstm32) aims to create
 * a free/libre/open-source (GPL v3, or later) firmware library for various
 * ARM Cortex-M3 microcontrollers, including ST STM32, Toshiba TX03,
 * Atmel SAM3U, NXP LPC1000 and others.
 *
 * @par ""
 *
 * See the <a href="http://www.libopencm3.org">libopencm3 wiki</a> for
 * more information.

LGPL License Terms @ref lgpl_license

*/

/** @page lgpl_license libopencm3 License

libopencm3 is free software: you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by the Free
Software Foundation, either version 3 of the License, or (at your option) any
later version.

libopencm3 is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License along with this
program.  If not, see <http://www.gnu.org/licenses/>.

*/

/** @defgroup LM3S
Libraries for Texas instruments LM3S series.
*/

/** @defgroup LPC13xx
Libraries for NXP Semiconductor LPC13xx series.
*/

/** @defgroup LPC17xx
Libraries for NXP Semiconductor LPC17xx series.
*/

/** @defgroup STM32F
Libraries for ST Microelectronics STM32F series.
*/

/** @defgroup STM32F1xx
@ingroup STM32F
Libraries for ST Microelectronics STM32F1xx series.
*/

/** @defgroup STM32F2xx
@ingroup STM32F
Libraries for ST Microelectronics STM32F2xx series.
*/

/** @defgroup STM32F4xx
@ingroup STM32F
Libraries for ST Microelectronics STM32F4xx series.
*/

